clear all
close all
clc
%% Preberi vse najbolje podatke
T1= readtable('S_PID2_4.xlsx');
T2= readtable('S_PID5_1.xlsx');
T3 = readtable('S_PID11_1.xlsx');
T4 = readtable('S_PID14_1.xlsx');
T5 = readtable('S_PID23_1.xlsx');
T6 = readtable('S_FPID21_2.xlsx');
T7 = readtable('S_FPID22_2.xlsx');
T8 = readtable('S_FPID24_4.xlsx');
T9 = readtable('S_FPID24_5.xlsx');
%% Zapii vse elemente o asu
Time(:,1)=table2array(T1(:,1));
%% Zapii vse elemente o poloaju
Distance(:,1)=table2array(T1(:,2));
Distance(:,2)=table2array(T2(:,2));
Distance(:,3)=table2array(T3(:,2));
Distance(:,4)=table2array(T4(:,2));
Distance(:,5)=table2array(T5(:,2));
Distance(:,6)=table2array(T6(:,2));
Distance(:,7)=table2array(T7(:,2));
Distance(:,8)=table2array(T8(:,2));
Distance(:,9)=table2array(T9(:,2));
%% Zapii vse elemente o eljeni poziciji
Wanted(:,1)=table2array(T1(:,3));
Wanted(:,2)=table2array(T2(:,3));
Wanted(:,3)=table2array(T3(:,3));
Wanted(:,4)=table2array(T4(:,3));
Wanted(:,5)=table2array(T5(:,3));
Wanted(:,6)=table2array(T6(:,3));
Wanted(:,7)=table2array(T7(:,3));
Wanted(:,8)=table2array(T8(:,3));
Wanted(:,9)=table2array(T9(:,3));
%% Zapii vse elemente o Kp
Kp(1)=table2array(T1(1,7));
Kp(2)=table2array(T2(1,7));
Kp(3)=table2array(T3(1,7));
Kp(4)=table2array(T4(1,7));
Kp(5)=table2array(T5(1,7));
Kp(6)=table2array(T7(1,7));
Kp(7)=table2array(T7(1,7));
Kp(8)=table2array(T8(1,7));
Kp(9)=table2array(T9(1,7));
%% Zapii vse elemento o Ki
Ki(1)=table2array(T1(1,9));
Ki(2)=table2array(T2(1,9));
Ki(3)=table2array(T3(1,9));
Ki(4)=table2array(T4(1,9));
Ki(5)=table2array(T5(1,9));
Ki(6)=table2array(T6(1,9));
Ki(7)=table2array(T7(1,9));
Ki(8)=table2array(T9(1,9));
Ki(9)=table2array(T9(1,9));
%% Zapii vse elemente o Kd
Kd(1)=table2array(T1(1,8));
Kd(2)=table2array(T2(1,8));
Kd(3)=table2array(T3(1,8));
Kd(4)=table2array(T4(1,8));
Kd(5)=table2array(T5(1,8));
Kd(6)=table2array(T6(1,8));
Kd(7)=table2array(T8(1,8));
Kd(8)=table2array(T8(1,8));
Kd(9)=table2array(T8(1,8));
%% Zapii vse elemente o landa l
l(6)=table2array(T6(1,10));
l(7)=table2array(T7(1,10));
l(8)=table2array(T8(1,10));
l(9)=table2array(T9(1,10));
%% Zapii vse elemente o miu m
u(6)=table2array(T6(1,11));
u(7)=table2array(T7(1,11));
u(8)=table2array(T8(1,11));
u(9)=table2array(T9(1,11));
%% Pridobi podatke o stopninem odzivu sistema
for i=1:1:9
    S(i) = stepinfo(Distance(:,i),Time,0.5);
end
%% Izrii odziv
for i=1:1:9
figure(i)
plot(Time,Distance(:,i),Time,Wanted(:,2))
grid on
xlabel('as [s]');
ylabel('Pomik [mm]');
legend('Poloaj','eljeni poloaj')
dim1 = [.6 .33 .4 .4];
dim2 = [.6 .33 .333 .333];
dim3 = [.6 .33 .266 .266];
dim4 = [.6 .33 .2 .2];
dim5 = [.6 .33 .133 .133];
dim6 = [.6 .33 .066 .066];
if i>5
dim7 = [.6 .263 .066 .066];
dim8 = [.6 .198 .066 .066];
end
% Zapii vzponski as, prenihaj in as umiritve
str1=strcat('Vzponski as [s]=', num2str(S(i).RiseTime));
str2=strcat('Prenihaj [%]=', num2str(S(i).Overshoot));
str3=strcat('as umiritve [s]=', num2str(S(i).SettlingTime));
% Zapii Parametre PID regulatorja
str4=strcat('Kp=', num2str(Kp(i)));
str5=strcat('Kd=', num2str(Kd(i)));
str6=strcat('Ki=', num2str(Ki(i)));
if i>5
str7=strcat('l=', num2str(l(i)));
str8=strcat('u=', num2str(u(i)));
end
annotation('textbox',dim1,'String',str1,'FitBoxToText','on');
annotation('textbox',dim2,'String',str2,'FitBoxToText','on');
annotation('textbox',dim3,'String',str3,'FitBoxToText','on');
annotation('textbox',dim4,'String',str4,'FitBoxToText','on');
annotation('textbox',dim5,'String',str5,'FitBoxToText','on');
annotation('textbox',dim6,'String',str6,'FitBoxToText','on');
if i>5
annotation('textbox',dim7,'String',str7,'FitBoxToText','on');
annotation('textbox',dim8,'String',str8,'FitBoxToText','on');
end
end