%% Stopnini odziv sistema DEA 
close all
format compact
m=0.0001;
k1=0.138645;
c1=0.086904;
a1=0.47;
b1=0;
m=0.0001;
k2=0.163922;
c2=0.127466;
a2=0.89;
b2=0.024;
%%Stopnica ali rampa
%s=1 rampa s=0 stopnica
t1=0:0.001:5;
s=0;
%% Velikost odziva d=1 -> 1 mm ali d=0 -> 6 mm
dv=1; 
%% Korak diskretne simulacije-velja za diskretno simulacijo SImulink
k=0.0001;
%% Elektrina karakteristika elastomera
e0=8.85e-12;  
er=47;      % iz virov sem razbral, da je dielektrina konstanta 4,7
% y=0.033;
y=0.06;
% d=0.0001;
d=0.00016; %v metrih v eksperimentu sem raztegnil elastmer do debeline 0.16mm
Fmax1=y*e0*er/(2*d);
Fmax2=y*e0*er/(2*d);
Kpf=5.665; 
Kif=7.179;
Kdf=0.03107;
l=0.868;
u=0.9;
Kp=5.665;
Ki=7.179;
Kd=0.0311;
%%
G=fotf([m c1 k1],[2 a1 b1],1,0);
FPID=fotf(1,l,[Kdf Kpf Kif],[l+u l 0]); %  FPID
FPIDG=mtimes(FPID,G);
[GmFPIDG,PmFPIDG,WcgFPIDG,WcpFPIDG] = margin(FPIDG)
CFPIDG=feedback(FPIDG,1);
% Dodan I len FPID
FPIID=fotf(1,1,[Kdf Kpf Kif],[1+u 1-l 1]); 
FPIIDG=mtimes(FPIID,G);
CFPIIDG=feedback(FPIIDG,1);
%% PID
PIDtf=fotf(1,1,[Kd Kp Ki],[2 1 0]);
PIDtfG=mtimes(PIDtf,G);
[GmPIDtfG,PmPIDtfG,WcgPIDtfG,WcpPIDtfG] = margin(PIDtfG)
CPIDtfG=feedback(PIDtfG,1);
%% Pretvorba PID v Oustaloup aproksimacijo
wb=1e-5;
wh=1e5;
N=4;
s=tf('s');
oust1=oustafod(1,N,wb,wh);
PIDoust=Kp+Ki/oust1+Kd*oust1;
%% PIDoust v zpk in c2d
PIDoustzpk=zpk(PIDoust);
PIDoustzpkc2d=c2d(PIDoustzpk,k,'matched');
ZPKPID_Z=cell2mat(PIDoustzpkc2d.Z);
ZPKPID_P=cell2mat(PIDoustzpkc2d.P);
ZPKPID_K=PIDoustzpkc2d.K;
%% pretvorba modela FD-KV v Oustaloup aproksimacijo
g1M=oustafod(a1,N,wb,wh);
gM2=oustafod(b1,N,wb,wh);
GM=1/(m*s^2+c1*g1M+k1);
%% zaprta zanka Oustaloup modela in oustalou PID
GMPIDoust=mtimes(PIDoust,GM);
CGMPIDoust=feedback(GMPIDoust,1);
%% sedaj je potrebno pretvoriti FPID v diskretni ZPK model, kjer najprej OUSTALOUP-ovo ... 
... aproksimacijo napiem v ZPK model, potem pa pretvorim v c2d
wb=1e-4;
wh=1e4;
N=4;
s=tf('s');
g1=oustafod(l,N,wb,wh);
g2=oustafod(u,N,wb,wh);
g1I=oustafod(1-l,N,wb,wh);
% FPID v OUSTALOUP filtru
G3=Kpf+Kif/g1+Kdf*g2;
% dodan I len FPID v OUSTALOUP filtru
G3I=Kpf+Kif*g1I/s+Kdf*g2;
w=logspace(-4,4,100);
% FPID to ZPK
G3zpk=zpk(G3);
G3zpkc2d=c2d(G3zpk,k,'matched');
ZPK_Z=cell2mat(G3zpkc2d.Z);
ZPK_P=cell2mat(G3zpkc2d.P);
ZPK_K=G3zpkc2d.K;
% Closed loop control of oustaloup approksimation of FPID and FD-KV
G3G=mtimes(G3,GM);
[GmG3G,PmG3G,WcgG3G,WcpG3G] = margin(G3G)
CG3G=feedback(G3G,1);
% dodan I len FPID to ZPK
G3Izpk=zpk(G3I);
PIDoustzpkc2d=c2d(G3Izpk,k,'matched');
ZPKI_Z=cell2mat(PIDoustzpkc2d.Z);
ZPKI_P=cell2mat(PIDoustzpkc2d.P);
ZPKI_K=PIDoustzpkc2d.K;
% Closed loop control of oustaloup approksimation of additional I part FPID and FD-KV
G3IG=mtimes(G3I,GM);
[GmG3IG,PmG3IG,WcgG3IG,WcpG3IG] = margin(G3IG)
CG3IG=feedback(G3IG,1);
%%
t=0:0.1:20;
sim('PID_FD_KV_discrete_zpk')
sim('FPID_FD_KV_discrete_zpk')
%% Uporabljal step05 za FOTF
SFPID = step05(CFPIDG,t);
%% Uporabljal step05 za PID, saj je isto zapisana v fotf obliki
SPID=step05(CPIDtfG,t);
%% izberi prvi primerjavi i=PID j= FPID Izris realnega DEA
i=4;
j=8;
figure(10)
plot(t,SFPID,t,SPID,cas2Dzpk,FDKV_FPID_pozicija,cas2Dzpk,FDKV_PID_pozicija,...
    Time(:,1),Distance(:,i),Time(:,1),Distance(:,j),Time(:,1),Wanted(:,1))
% legend('Laplace PIlDu','Laplace PID','Simulink disk PIlDu','Simulink disk PID',...
%     'PID realni','PIlDu realni','eljeni')
% xlabel('as [s]');
% ylabel('Pomik [mm]');
%% angleko
legend('Laplace PIlDu','Laplace PID','Simulink disc PIlDu','Simulink disc PID',...
    'PID real','PIlDu real','Wanted')
xlabel('Time [s]');
ylabel('Displacement [mm]');
grid on
stepinfo1=stepinfo(SFPID,t,0.5,'RiseTimeLimits',[0.05,0.95])
stepinfo2=stepinfo(SPID,t,0.5,'RiseTimeLimits',[0.05,0.95])
stepinfo3=stepinfo(FDKV_PID_pozicija,cas2Dzpk,0.5,'RiseTimeLimits',[0.05,0.95])
stepinfo4=stepinfo(FDKV_FPID_pozicija,cas2Dzpk,0.5,'RiseTimeLimits',[0.05,0.95])
stepinfo5=stepinfo(Distance(:,i), Time(:,1),0.5,'RiseTimeLimits',[0.05,0.95])
stepinfo6=stepinfo(Distance(:,j),Time(:,1),0.5,'RiseTimeLimits',[0.05,0.95])


